#ifndef EFL_UI_MENU_EO_HH
#define EFL_UI_MENU_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_item.eo.h"
#include "efl_ui_menu.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_ui_item.eo.hh"
namespace efl { namespace ui { 
struct Menu;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Menu> : ::std::true_type {}; } }
namespace efl { namespace ui { 
struct Menu;
} } 
namespace efl { namespace ui { 
struct Item;
} } 

namespace eo_cxx {
namespace efl { namespace ui { 
struct Menu {
   ::efl::eolian::return_traits< ::efl::ui::Item>::type selected_item_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type first_item_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type last_item_get() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::ui::Item>>::type items_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_MENU_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Menu() const;
   operator ::efl::ui::Menu&();
   operator ::efl::ui::Menu const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Menu> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Menu const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Menu : ::efl::eo::concrete
{
   explicit Menu( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Menu(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Menu(Menu const& other) = default;
   Menu(Menu&& other) = default;
   Menu& operator=(Menu const& other) = default;
   Menu& operator=(Menu&& other) = default;
   Menu()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Menu( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Menu(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::ui::Item>::type selected_item_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type first_item_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type last_item_get() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::ui::Item>>::type items_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_MENU_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Menu> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Menu const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Menu) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Menu>::value, "");
} } 
#endif
